菜单

java异常处理(父子异常的处理),java异常处理

2018年11月16日 - Java

 java.lang.Throwable

java异常处理(父子异常的处理),java异常处理

  我当场学java异常处理的时刻,对于父子异常的拍卖,我记忆几句子话“子类方法只有能够弃来父类方法所抛弃来的生要是其子异常,子类构造器必须要摒弃来父类构造器的良要其大异常”。那个时候还未知道子类方法为什么而就则抛来非常,后来通过学习《Thinking
in Java》,我才知其中的理,现在自再来温习一下。

相同、子类方法就能够丢弃来父类方法的坏要是其子异常

  对于这种范围,主要是以子类在做向上转型的下,不克对地破获异常

package thinkinginjava;

public abstract class InningDemo1 {
    public void walk() throws BaseException{}
    public abstract void sing() throws BaseException;
}

class BaseException extends Exception{}
class SubException1 extends BaseException{}
class CupException extends Exception{}

package thinkinginjava;

public interface OtherFunction {
    public void task() throws RuntimeException;
} 

 

package thinkinginjava;

public class SubInningDemo1 extends InningDemo1 implements OtherFunction{
    //子类方法可以抛出父类方法的异常
    @Override
    public void walk() throws BaseException{}

    //但不能抛出父类中没有的异常,否则编译会出错
    //public void walk() throws Exception{}

    //子类方法可以抛出父类方法的子异常
    @Override
    public void sing() throws SubException1{}

    //当实现的接口和父类中的方法都有异常时,可以选择不抛出异常
    public void task(){}

}

 

  就将这例子来说,假如子类中出立办法 public void walk()
throws CupException{},抛来了父类方法无的百般,我们应用父类的援指向子类

  public void f(){

    InningDemo1 inn = new SubInningDemo1();

    inn.walk()
;//父类调用walk()方法时,并不知道它见面丢掉来CupException,从而f()方法不知哪捕获异常。因此于编译期就要防止子类方法乱丢弃大。

  }

  从点的事例中,我们为得以观看,子类方法好免废来很

 

亚、子类构造器必须使摒弃来父类构造器的生或者其大异常

  这是坐子类构造器中默认添加了父类的构造器

package thinkinginjava;

public abstract class InningDemo2 {
    public InningDemo2() throws SubException{

    }
}

class FatherException extends Exception{}
class SubException extends FatherException{}
class PenException extends Exception{}

package thinkinginjava;

public class SubInningDemo2 extends InningDemo2{
    public SubInningDemo2() throws FatherException {
        //子类构造器中默认添加了父类的构造器,所以需要抛出父类的异常或者其父异常
        //super();
    }
}

 

其三、异常掉

1、在finally中丢掉来异常,可能会见之前抛来之怪掉

package thinkinginjava;

public class FinallyException {
    public static void main(String[] args){
        try{
            try{
                throw new RedException();
            }finally{
                //把上一个异常覆盖掉
                throw new BlueException();
            }
        }catch(Exception e){
            System.out.println(e);
        }
    }
}

class RedException extends Exception{}
class BlueException extends Exception{}

 

运作结果:thinkinginjava.BlueException

2、在finally中运用return,不会见废弃来好

package thinkinginjava;

public class ReturnException {
    public static void main(String[] args){
        try{
            throw new Exception();
        }finally{
            return;
        }
    }
}

上述代码我们视她抛来了好,但运行时未见面产生另输出

 

http://www.bkjia.com/Javabc/1156136.htmlwww.bkjia.comtruehttp://www.bkjia.com/Javabc/1156136.htmlTechArticlejava异常处理(父子异常的处理),java异常处理
我那时学java异常处理的时节,对于父子异常的拍卖,我记得几词话子类方法就会丢弃来父类方…

Error 错误 程序中不处理

Exception 异常 ,在编写程序时,要考虑针对这些酷的处理

不行分为编译时好、运行时老 (RuntimeException)。

当尽一个先后时,如果出现异常,则充分后的代码就不再实行

广阔的运作时坏: 1、数组下标越界异常  2、算术异常 3、类型转化异常
4、空指针异常

 1 public class TestException
 2 {
 3    @Test
 4    public void test1(){
 5        int [] i=new int [10];
 6        System.out.println(i[10]);
 7    }
 8    
 9    @Test
10    public void test2(){
11        System.out.println(1/0);
12    }
13    
14    @Test
15    public void test3(){
16        Object obj=new Date();
17        String str=(String) obj;
18    }
19    
20    @Test
21    public void test4(){
22        Person p=new Person();
23        p=null;
24        System.out.println(p.toString());
25    }
26 }

java 提供的是老处理的抓抛模型

1、抛
:当我们执行代码时,一旦出现异常,就见面于很的代码处生成一个对应之怪类型的靶子,并以这个目标抛来。一旦丢来此类型的目标,那么程序终止执行,此颇类的靶子抛给艺术的调用者

2、抓:抓住上同样步抛出来的非常类的目标。java中提供了区区栽方法来拍卖一个良类的对象。

处理方式一: try{

    可能扔来好的代码

}catch( exception e){

  处理好

} finally{

  一定要是实行之代码(可选)

}

若catch 基本上个要命类型,是一视同仁关系,catch的逐一没有涉嫌;若catch
的不行是含关系,则范围稍的(子类)一定要是描写于(父类)上面。

finally
中存放的凡一定会实施之代码,不管catch中是否出好或者return语句。

处理方式二:

相关文章

发表评论

电子邮件地址不会被公开。 必填项已用*标注

网站地图xml地图